<template>
  <el-row>
    <el-col :span="24">
      <el-table @row-click="goto" :data="GETTERS_CARS || []">
        <el-table-column prop="model" label="Model" width="180">
        </el-table-column>
        <el-table-column prop="purchase_date" label="Purchase date" width="180">
        </el-table-column>
        <el-table-column prop="mileage" label="Mileage, mi"> </el-table-column>
        <el-table-column prop="registration_mark" label="Registration mark">
        </el-table-column>

        <el-table-column prop="car_type_id" label="Car type">
        </el-table-column>

        <el-table-column fixed="right" label="Operations">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="danger"
              @click.stop="handleDeleteCar(scope.row)"
              >Delete</el-button
            >
          </template>
        </el-table-column>
      </el-table>
    </el-col>

    <el-col :span="24">
      <el-pagination
        background
        @size-change="ACTIONS_CARS_PAGE_SIZE_CHANGE"
        :total="GETTERS_CARS_TOTAL_COUNT"
        layout="sizes,prev, pager, next"
      >
      </el-pagination>
    </el-col>
  </el-row>
</template>

<script>
  import {
    ACTIONS_GET_CARS,
    ACTIONS_DELETE_CAR,
    ACTIONS_CARS_PAGE_SIZE_CHANGE,
    GETTERS_CARS,
    GETTERS_CARS_TOTAL_COUNT,
  } from "@/plugins/constants";
  import { mapGetters, mapActions } from "vuex";

  export default {
    methods: {
      handleDeleteCar(row) {
        if (!row || !row.hasOwnProperty("id")) return;

        this.ACTIONS_DELETE_CAR(row.id)
          .then((_) => {
            this.$notify.success({ message: "Car successfully deleted" });
          })
          .catch(({ response }) => this.$notify.error({ message: response.data }))
          .finally(() => this.ACTIONS_GET_CARS());
      },

      ...mapActions({
        ACTIONS_DELETE_CAR,
        ACTIONS_GET_CARS,
        ACTIONS_CARS_PAGE_SIZE_CHANGE,
      }),

      goto(row) {
        if (row && row.id)
          this.$router.push({ name: "Car", params: { id: row.id } });
      },
    },
    computed: {
      ...mapGetters({ GETTERS_CARS, GETTERS_CARS_TOTAL_COUNT }),
    },
    mounted() {
      this.ACTIONS_GET_CARS().catch((error) =>
        this.$notify.error({ message: "Something went wrong" })
      );
    },
  };
</script>

<style>
  tr {
    cursor: pointer;
  }
</style>